variables:
    GIT_SUBMODULE_STRATEGY: recursive
    USE_JADE: "ON"
    UNICODE: "OFF"

cache:
    key: "${CI_JOB_NAME}-${CI_COMMIT_REF_NAME}"

.build:
    stage: build
    image: registry.gitlab.com/jadelab/buildtools
    script:
        - cmake -S . -B build -A x64 -D CMAKE_INSTALL_PREFIX:PATH=.. -D USE_JADE=${USE_JADE} -D JADE_VERSION=${JADE_VERSION} -D UNICODE=${UNICODE}
        - cmake --build build --config "${BUILD_CONFIG}" --target install
        - cd build
        - bin/jadegit --version
        - bin/jadegit_test -r junit -o report.xml
    artifacts:
        name: "${CI_JOB_NAME}-${CI_COMMIT_REF_SLUG}"
        paths:
        - bin/jadegit*.*
        reports:
          junit: build/report.xml
    tags:
        - docker
        - windows

jadegit-20.0.02-ansi:
    extends:
        - .build
    variables:
        JADE_VERSION: "20.0.02"

jadegit-20.0.02-unicode:
    extends:
        - .build
    variables:
        JADE_VERSION: "20.0.02"
        UNICODE: "ON"

jadegit-22.0.01-ansi:
    extends:
        - .build
    variables:
        JADE_VERSION: "22.0.01"

jadegit-22.0.01-unicode:
    extends:
        - .build
    variables:
        JADE_VERSION: "22.0.01"
        UNICODE: "ON"

jadegit-console:
    extends:
        - .build
    variables:
        USE_JADE: "OFF"